package org.jboss.security;

package .tmp;

import java.security.Principal;
import java.security.acl.Group;
import java.util.Enumeration;
import java.util.LinkedList;
import org.jboss.security.SimplePrincipal;

public class NestableGroup extends SimplePrincipal implements Group {
  private LinkedList rolesStack;
  
  public NestableGroup(String name) {
    super(name);
    this.rolesStack = new LinkedList();
  }
  
  public Enumeration members() {
    return (Enumeration)new IndexEnumeration(this);
  }
  
  public boolean removeMember(Principal user) {
    return this.rolesStack.remove(user);
  }
  
  public boolean addMember(Principal group) throws IllegalArgumentException {
    if (!(group instanceof Group))
      throw new IllegalArgumentException("The addMember argument must be a Group"); 
    this.rolesStack.addFirst(group);
    return true;
  }
  
  public boolean isMember(Principal member) {
    if (this.rolesStack.size() == 0)
      return false; 
    Group activeGroup = this.rolesStack.getFirst();
    boolean isMember = activeGroup.isMember(member);
    return isMember;
  }
  
  public String toString() {
    StringBuffer tmp = new StringBuffer(getName());
    tmp.append("(members:");
    Enumeration iter = members();
    while (iter.hasMoreElements()) {
      tmp.append(iter.nextElement());
      tmp.append(',');
    } 
    tmp.setCharAt(tmp.length() - 1, ')');
    return tmp.toString();
  }
}
